import 'package:test/test.dart';

import '../test_helper.dart';

void theory<TData>(List<TData> inlineData, void Function(TData data) theory) {
  inlineData.forEach(theory);
}

void theoryAsync<TData>(
    List<TData> inlineData, Future<void> Function(TData data) theory) async {
  for (var data in inlineData) {
    await theory(data);
  }
}

void theoryResult<TData, TResult>(List<TData> inlineData,
    List<TResult> expected, TResult Function(TData data) act) {
  final results = inlineData.map(act).toList();
  _assertResults(results, expected);
}

void theoryResultAsync<TData, TResult>(List<TData> inlineData,
    List<TResult> expected, Future<TResult> Function(TData data) act) async {
  final results = List<TResult>.empty(growable: true);
  for (var dataItem in inlineData) {
    final res = await act(dataItem);
    results.add(res);
  }
  //final results = inlineData.map((data) async => await act(data)).toList();
  _assertResults(results, expected);
}

void _assertResults<TResult>(List<TResult> actual, List<TResult> expected) {
  try {
    expectList(actual, expected);
  } on TestFailure {
    throw TestFailure(
        "Theory failed because actual result (${actual.toString()}) did not match expected (${expected.toString()})");
  }
}
